--------------------------------------------------------------------------------
-- Weapon Taste Miasma + Miasmic Ball
-- Original Carnage Contest Weapon
-- Script by Wall lll, December 2011, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if ccm==nil then ccm={} end
ccm.tastemiasma={}
ccm.tastemiasma.cluster={}
ccm.tastemiasma.plane={}

-- Load & prepare resources
ccm.tastemiasma.gfx_wpn=loadgfx("weapons/miasmaball.bmp")				-- Weapon image
setmidhandle(ccm.tastemiasma.gfx_wpn)
ccm.tastemiasma.gfx_icon=loadgfx("weapons/miasmaicon.png")				-- Weapon icon
setmidhandle(ccm.tastemiasma.gfx_icon)
ccm.tastemiasma.gfx_pro=loadgfx("weapons/miasmaball.bmp")				-- Projectile image
setmidhandle(ccm.tastemiasma.gfx_pro)
ccm.tastemiasma.gfx_plane=loadgfx("weapons/miasmaportal.png")				-- Portal image
setmidhandle(ccm.tastemiasma.gfx_plane)
ccm.tastemiasma.sfx_attack=loadsfx("TasteMiasma.ogg")					-- Attack sound

--------------------------------------------------------------------------------
-- Weapon: Taste Miasma
--------------------------------------------------------------------------------

ccm.tastemiasma.id=addweapon("ccm.tastemiasma","Taste Miasma",ccm.tastemiasma.gfx_icon,0,3)	-- Add weapon (0 uses, first in round 3)

function ccm.tastemiasma.draw()						-- Draw
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(ccm.tastemiasma.gfx_wpn,7,0)
	-- HUD Positioning
	if weapon_shots==0 then
		hudpositioning(pos_invisible)
	end
end

function ccm.tastemiasma.attack(attack)					-- Attack
	if (weapon_shots<=0) and (weapon_position==1) then
		-- No more weapon switching!
		useweapon(0)
		playsound(ccm.tastemiasma.sfx_attack)
		weapon_shots=weapon_shots+1
		-- Attack
--[[		for i=0,2,1 do
			for j=-2,2,1 do
				pid=createprojectile(ccm.tastemiasma.cluster.id)
				projectiles[pid]={}
				projectiles[pid].x=weapon_x+(j*15)
				projectiles[pid].y=-500-(i*500)
				projectiles[pid].sx=0
				projectiles[pid].sy=5.0
				if i==0 and j==0 then projectiles[pid].follow=1 end
			end
		end]]
		local id
		
		-- create portal
		for i=0,2 do
			id=createprojectile(ccm.tastemiasma.plane.id)
			projectiles[id]={}
			if(getplayerdirection(0)==1) then
				projectiles[id].x=math.min(weapon_x-1000-1500*i, -1000-1500*i)
				projectiles[id].sx=40
			else
				projectiles[id].x=math.min(weapon_x+1000+1500*i, getmapwidth()+1000+1500*i)
				projectiles[id].sx=-40
			end
			projectiles[id].y=-512
			projectiles[id].throwindex=-2
			projectiles[id].dropx=weapon_x
			projectiles[id].id=i
		end
		scroll(weapon_x,-512)
		-- End Turn
		endturn()
	end
end

--------------------------------------------------------------------------------
-- Projectile: Portal
--------------------------------------------------------------------------------
ccm.tastemiasma.plane.id=addprojectile("ccm.tastemiasma.plane")

function ccm.tastemiasma.plane.draw(id)
	local dir
	-- direction
	if(projectiles[id].sx>0) then
		dir=1
	else
		dir=-1
	end
	setblend(blend_alpha)
	setalpha(1)
	setcolor(127,127,127)
	setscale(dir,1)
	setrotation(0)
	drawimage(ccm.tastemiasma.gfx_plane,projectiles[id].x,projectiles[id].y)
end

function ccm.tastemiasma.plane.update(id)
	local dir
	if(projectiles[id].sx>0) then
		dir=1
	else
		dir=-1
	end
	-- Particles
	particle(p_muzzle, projectiles[id].x, projectiles[id].y)
	particlesize(1,1)
	particlecolor(145,12,193)
	particlefadealpha(1)

	-- move
	projectiles[id].x=projectiles[id].x+projectiles[id].sx
	if(projectiles[id].throwindex<=2) then
		local dropx=projectiles[id].throwindex*15*dir
		if(dir==1 and projectiles[id].x>=projectiles[id].dropx+dropx) or (dir==-1 and projectiles[id].x<=projectiles[id].dropx+dropx) then
			-- Attack
			projectiles[id].throwindex=projectiles[id].throwindex+1
			pid=createprojectile(ccm.tastemiasma.cluster.id)
			projectiles[pid]={}
			projectiles[pid].x=projectiles[id].dropx+dropx
			projectiles[pid].y=-500
			projectiles[pid].sx=dir*0.2
			projectiles[pid].sy=3.0 
			if projectiles[id].id==0 and projectiles[id].throwindex==0 then
				projectiles[pid].follow=true
			else
				projectiles[pid].follow=false
			end
		end
	end
		
	-- remove portal
	if(dir==1 and projectiles[id].x>projectiles[id].dropx+10000 and projectiles[id].x>(getmapwidth()+10000)) or (dir==-1 and projectiles[id].x<projectiles[id].dropx-10000 and projectiles[id].x<-10000) then
		freeprojectile(id)
	end
end

--------------------------------------------------------------------------------
-- Projectile: Miasmic Ball
--------------------------------------------------------------------------------

ccm.tastemiasma.cluster.id=addprojectile("ccm.tastemiasma.cluster")	-- Add Projectile

function ccm.tastemiasma.cluster.draw(id)								-- Draw
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	-- Calculate projectile rotation
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	-- Draw projectile
	drawimage(ccm.tastemiasma.gfx_pro,projectiles[id].x,projectiles[id].y)
end

function ccm.tastemiasma.cluster.update(id)							-- Update
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	-- Particle Tail
	particle(p_muzzle, projectiles[id].x, projectiles[id].y)
	particlesize(1,1)
	particlecolor(145,12,193)
	particlefadealpha(1)
	-- Gravity influence on speed
	projectiles[id].sy=projectiles[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby
		-- Collision
		if collision(col3x3,projectiles[id].x,projectiles[id].y)==1 then
			-- Cause damage
			arealdamage(projectiles[id].x,projectiles[id].y,30,45)
			particle(p_ring,projectiles[id].x,projectiles[id].y)			
			particlesize(5,1)
			particlecolor(145,12,193)
			-- Free projectile
			freeprojectile(id)
			break
		end
		-- Poison Players
		players=playertable()
		for i=1,#players,1 do
			if getplayerhealth(players[i])>0 then
				if math.sqrt((getplayerx(players[i])-projectiles[id].x)^2+(getplayery(players[i])-projectiles[id].y)^2)<=70 then
					playerstate(players[i],state_poisoned,1)
				end
			end
		end
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			-- Free projectile
			freeprojectile(id)
			break
		end
	end
	-- Scroll to projectile
	if projectiles[id].follow==true then
		scroll(projectiles[id].x,projectiles[id].y)
	end
end
